PROGRAM gen_dat;

CONST MMAX=100;

TYPE real=double;

     Data=RECORD
       abscissa  : real;
       ordinate  : real;
     END;

     dataabscissae    = ARRAY [1..MMAX] OF real;
     datavalues       = ARRAY [1..MMAX] OF real;

VAR DataFile   : FILE OF Data;
    DataRec    : Data;
    Filename   : STRING;

    m         : integer;        { number of data values (tau[i],y[i]) i=1..m }
    tau       : dataabscissae;
    y         : datavalues;
    a,b       : real;
    i         : Integer;
    err,variance,expect       : real;

FUNCTION f ( x: real ) :real;
CONST eps=0.1;
BEGIN
 f:=arctan(x/eps);
END;

PROCEDURE Data_To_Disk;
VAR i : integer;

BEGIN
  FileName:='TEST.DTA';
  Assign(DataFile,FileName);
  Rewrite(DataFile);
  WITH DataRec DO
    BEGIN
      FOR i:=1 TO m DO
        BEGIN
          abscissa:= tau[i];
          ordinate:= y[i];
          Write(DataFile,DataRec);
        END;
    END;
  Close(DataFile);
END;  { Data_To_Disk }
BEGIN
  m:=41;
  a:=-10;
  b:=10;
  FOR i:=1 TO m DO
    tau[i]:=a+(b-a) * (i-1)/(m-1);  { equidistant data points }

  variance:=0.0;
  expect:=0.0;
  Randomize;
  FOR i:=1 TO m DO
    BEGIN
      err:=0.075* (2*Random-1); { between -0.05 .. 0.05 }
      { err relative }
      y[i]:=f(tau[i])+err*f(tau[i]);
      variance:=variance+Sqr(err);
      expect:=expect+err;
    END;
  expect:=expect/m;
  variance:=variance/m-Sqr(expect);
  WriteLn('Variance : ',variance);
  WriteLn('Expectation : ',expect);
  Data_to_Disk;
END.